/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/


/*************  ˵    **************

CC1TI1,CC2TI1½.(P1.0)
CC3TI3,CC4TI3½.(P1.4)
CC5TI5,CC6TI5½.(P1.7)
CC7TI7,CC8TI7½.(P2.2)

ģʽߵƽ.

ʱ=׽ʱ/PWMʱԴ,  ׽ʱ = 255, PWMʱԴ = 24MHz(1T),  = 255/24MHz = 10.625us.

ʱ, ѡʱ 11.0592MHZ (û޸Ƶ).

******************************************/

#include "STC32G.h"
#include "stdio.h"

typedef 	unsigned char	u8;
typedef 	unsigned int	u16;
typedef 	unsigned long	u32;

#define MAIN_Fosc       11059200L   //ʱ
#define MCLK            (MAIN_Fosc/1000000L)
#define Timer0_Reload   (MAIN_Fosc / 10000)      //Timer 0 жƵ, 10000/

#define PrintUart     1        //1:printf ʹ UART1; 2:printf ʹ UART2
#define Baudrate      115200L
#define TM            (65536 -(MAIN_Fosc/Baudrate/4))


#define PWM1_1      0x00	//P:P1.0  N:P1.1
#define PWM1_2      0x01	//P:P2.0  N:P2.1
#define PWM1_3      0x02	//P:P6.0  N:P6.1

#define PWM2_1      0x00	//P:P1.2/P5.4  N:P1.3
#define PWM2_2      0x04	//P:P2.2  N:P2.3
#define PWM2_3      0x08	//P:P6.2  N:P6.3

#define PWM3_1      0x00	//P:P1.4  N:P1.5
#define PWM3_2      0x10	//P:P2.4  N:P2.5
#define PWM3_3      0x20	//P:P6.4  N:P6.5

#define PWM4_1      0x00	//P:P1.6  N:P1.7
#define PWM4_2      0x40	//P:P2.6  N:P2.7
#define PWM4_3      0x80	//P:P6.6  N:P6.7
#define PWM4_4      0xC0	//P:P3.4  N:P3.3

#define PWM5_1      0x00	//P2.0
#define PWM5_2      0x01	//P1.7
#define PWM5_3      0x02	//P0.0
#define PWM5_4      0x03	//P7.4

#define PWM6_1      0x00	//P2.1
#define PWM6_2      0x04	//P5.4
#define PWM6_3      0x08	//P0.1
#define PWM6_4      0x0C	//P7.5

#define PWM7_1      0x00	//P2.2
#define PWM7_2      0x10	//P3.3
#define PWM7_3      0x20	//P0.2
#define PWM7_4      0x30	//P7.6

#define PWM8_1      0x00	//P2.3
#define PWM8_2      0x40	//P3.4
#define PWM8_3      0x80	//P0.3
#define PWM8_4      0xC0	//P7.7

/*****************************************************************************/

unsigned int cnt1,cnt3,cnt5,cnt7;
unsigned int ccr1,ccr2,ccr3,ccr4,ccr5,ccr6,ccr7,ccr8;
bit Cap1Flag,Cap3Flag,Cap5Flag,Cap7Flag;

void Timer0_init(void);

/******************** ڴӡ ********************/
void UartInit(void)
{
#if(PrintUart == 1)
    SCON = (SCON & 0x3f) | 0x40; 
    T1x12 = 1;      //ʱʱ1Tģʽ
    S1BRT = 0;      //1ѡʱ1Ϊʷ
    TL1  = TM;
    TH1  = TM>>8;
    TR1 = 1;        //ʱ1ʼʱ

//    SCON = (SCON & 0x3f) | 0x40; 
//    T2L  = TM;
//    T2H  = TM>>8;
//    AUXR |= 0x15; //1ѡʱ2Ϊʷ
#else
    S2_S = 1;       //UART2 switch to: 0: P1.0 P1.1,  1: P4.6 P4.7
    S2CFG |= 0x01;  //ʹô2ʱW1λΪ1ܻԤڵĴ
    S2CON = (S2CON & 0x3f) | 0x40; 
    T2L  = TM;
    T2H  = TM>>8;
    AUXR |= 0x14;   //ʱ2ʱ1Tģʽ,ʼʱ
#endif
}

void UartPutc(unsigned char dat)
{
#if(PrintUart == 1)
    SBUF = dat; 
    while(TI==0);
    TI = 0;
#else
    S2BUF  = dat; 
    while(S2TI == 0);
    S2TI = 0;    //Clear Tx flag
#endif
}

char putchar(char c)
{
    UartPutc(c);
    return c;
}

void main()
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

	P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
	P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
	P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
	P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
	P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
	P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
	P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
	P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

	Timer0_init();
	UartInit();

	PWMA_PS = 0x00;  //߼ PWM ͨѡλ
	PWMA_PS |= PWM1_1; //ѡ PWM1_1 ͨ
//	PWMA_PS |= PWM2_1; //ѡ PWM2_1 ͨ
	PWMA_PS |= PWM3_1; //ѡ PWM3_1 ͨ
//	PWMA_PS |= PWM4_1; //ѡ PWM4_1 ͨ

	PWMB_PS = 0x00;    //߼ PWM ͨѡλ
	PWMB_PS |= PWM5_2; //ѡ PWM5_2 ͨ
//	PWMB_PS |= PWM6_2; //ѡ PWM6_2 ͨ
	PWMB_PS |= PWM7_1; //ѡ PWM7_1 ͨ
//	PWMB_PS |= PWM8_1; //ѡ PWM8_1 ͨ

	//(CC1TI1,CC2TI1½)
	PWMA_CCER1 = 0x00;
	PWMA_CCMR1 = 0x01;	//CC1Ϊģʽ,ӳ䵽TI1FP1
	PWMA_CCMR2 = 0x02;	//CC2Ϊģʽ,ӳ䵽TI1FP2
	PWMA_CCER1 = 0x11;	//ʹCC1/CC2ϵĲ
	PWMA_CCER1 |= 0x00;	//òΪCC1
	PWMA_CCER1 |= 0x20;	//òΪCC2½
//	PWMA_CR1 = 0x01;	//ʹܼ
	PWMA_IER = 0x04;	//ʹCC2ж

	//(CC3TI3,CC4TI3½)
	PWMA_CCER2 = 0x00;
	PWMA_CCMR3 = 0x01;	//CC3Ϊģʽ,ӳ䵽TI3FP3
	PWMA_CCMR4 = 0x02;	//CC4Ϊģʽ,ӳ䵽TI3FP4
	PWMA_CCER2 = 0x11;	//ʹCC3/CC4ϵĲ
	PWMA_CCER2 |= 0x00;	//òΪCC3
	PWMA_CCER2 |= 0x20;	//òΪCC4½
	PWMA_CR1 = 0x01;	//ʹܼ
	PWMA_IER |= 0x10;	//ʹCC4ж

	//(CC5TI5,CC6TI5½)
	PWMB_CCER1 = 0x00;
	PWMB_CCMR1 = 0x01;	//CC5Ϊģʽ,ӳ䵽TI5FP5
	PWMB_CCMR2 = 0x02;	//CC6Ϊģʽ,ӳ䵽TI5FP6
	PWMB_CCER1 = 0x11;	//ʹCC5/CC6ϵĲ
	PWMB_CCER1 |= 0x00;	//òΪCC5
	PWMB_CCER1 |= 0x20;	//òΪCC6½
//	PWMB_CR1 = 0x01;	//ʹܼ
	PWMB_IER = 0x04;	//ʹCC2ж

	//(CC7TI7,CC8TI7½)
	PWMB_CCER2 = 0x00;
	PWMB_CCMR3 = 0x01;	//CC7Ϊģʽ,ӳ䵽TI7FP7
	PWMB_CCMR4 = 0x02;	//CC8Ϊģʽ,ӳ䵽TI7FP8
	PWMB_CCER2 = 0x11;	//ʹCC7/CC8ϵĲ
	PWMB_CCER2 |= 0x00;	//òΪCC7
	PWMB_CCER2 |= 0x20;	//òΪCC8½
	PWMB_CR1 = 0x01;	//ʹܼ
	PWMB_IER |= 0x10;	//ʹCC8ж

	EA = 1;

	printf("PWM capture test.\r\n");

	while (1)
	{
		if(Cap1Flag)
		{
			printf("Result1=%i, Pulse 1 width=%.2fus\r\n",cnt1,(float)cnt1/MCLK);
			Cap1Flag = 0;
		}
		if(Cap3Flag)
		{
			printf("Result3=%i, Pulse 3 width=%.2fus\r\n",cnt3,(float)cnt3/MCLK);
			Cap3Flag = 0;
		}
		if(Cap5Flag)
		{
			printf("Result5=%i, Pulse 5 width=%.2fus\r\n",cnt5,(float)cnt5/MCLK);
			Cap5Flag = 0;
		}
		if(Cap7Flag)
		{
			printf("Result7=%i, Pulse 7 width=%.2fus\r\n",cnt7,(float)cnt7/MCLK);
			Cap7Flag = 0;
		}
	}
}

void PWMA_ISR() interrupt PWMA_VECTOR
{
	if (PWMA_SR1 & 0x04)
	{
		PWMA_SR1 &= ~0x04;

		ccr1 = (PWMA_CCR1H<<8) + PWMA_CCR1L;
		ccr2 = (PWMA_CCR2H<<8) + PWMA_CCR2L;
		cnt1 = ccr2 - ccr1;     //ֵΪߵƽ
		Cap1Flag = 1;
	}

	if (PWMA_SR1 & 0x10)
	{
		PWMA_SR1 &= ~0x10;

		ccr3 = (PWMA_CCR3H<<8) + PWMA_CCR3L;
		ccr4 = (PWMA_CCR4H<<8) + PWMA_CCR4L;
		cnt3 = ccr4 - ccr3;     //ֵΪߵƽ
		Cap3Flag = 1;
	}
}

void PWMB_ISR() interrupt PWMB_VECTOR
{
	if (PWMB_SR1 & 0x04)
	{
		PWMB_SR1 &= ~0x04;

		ccr5 = (PWMB_CCR5H<<8) + PWMB_CCR5L;
		ccr6 = (PWMB_CCR6H<<8) + PWMB_CCR6L;
		cnt5 = ccr6 - ccr5;     //ֵΪߵƽ
		Cap5Flag = 1;
	}

	if (PWMB_SR1 & 0x10)
	{
		PWMB_SR1 &= ~0x10;

		ccr7 = (PWMB_CCR7H<<8) + PWMB_CCR7L;
		ccr8 = (PWMB_CCR8H<<8) + PWMB_CCR8L;
		cnt7 = ccr8 - ccr7;     //ֵΪߵƽ
		Cap7Flag = 1;
	}
}

//========================================================================
// : void Timer0_init(void)
// : timer0ʼ.
// : none.
// : none.
// 汾: V1.0, 2015-1-12
//========================================================================
void Timer0_init(void)
{
        TR0 = 0;    //ֹͣ

    #if (Timer0_Reload < 64)    // ûֵʣ ʱ
        #error "Timer0õжϹ!"

    #elif ((Timer0_Reload/12) < 65536UL)    // ûֵʣ ʱ
        ET0 = 1;    //ж
    //  PT0 = 1;    //ȼж
        TMOD &= ~0x03;
        TMOD |= 0;  //ģʽ, 0: 16λԶװ, 1: 16λʱ/, 2: 8λԶװ, 3: 16λԶװ, ж
    //  TMOD |=  0x04;  //Ƶ
        TMOD &= ~0x04;  //ʱ
    //  INTCLKO |=  0x01;  //ʱ
        INTCLKO &= ~0x01;  //ʱ

        #if (Timer0_Reload < 65536UL)
            AUXR |=  0x80;  //1T mode
            TH0 = (u8)((65536UL - Timer0_Reload) / 256);
            TL0 = (u8)((65536UL - Timer0_Reload) % 256);
        #else
            AUXR &= ~0x80;  //12T mode
            TH0 = (u8)((65536UL - Timer0_Reload/12) / 256);
            TL0 = (u8)((65536UL - Timer0_Reload/12) % 256);
        #endif

        TR0 = 1;    //ʼ

    #else
        #error "Timer0õжϹ!"
    #endif
}

//========================================================================
// : void timer0_int (void) interrupt TIMER0_VECTOR
// :  timer0жϺ.
// : none.
// : none.
// 汾: V1.0, 2015-1-12
//========================================================================
void timer0_int (void) interrupt 1
{
	P20 = ~P20;		//
}

